#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<gsl/gsl_math.h>
#include<gsl/gsl_integration.h>

/*aqui esta el calculo de la funcion potencial*/
double Potencial(double U)
{
	double P0=-0.3;
	return P0 * U * ( log( 1.0 + U ) - log(U) );
}

/*Defino g00 y gRR*/
double g00(double U)
{
	/*printf("%f\n",1.0+2.0*Potencial(U));*/
	return 1.0 + 2.0 * Potencial(U);
}

double gRR(double U)
{
	double gamma = 1.0;
	/*printf("%f\n",-1.0+2.0*gamma*Potencial(U));*/
	return -1.0 + 2.0 * gamma * Potencial(U);
}

/*Defino la función dPhi/dR encontrada para el ángulo de deflección con métrica simétricamente esférica*/
double dPhidR(double U, double y, double U0)
{	
	printf("%f\n", ( 1.0 * g00(U) * gRR(U) ) / ((U*U*g00(U)) - (U0*U0*g00(U0))) );
	return sqrt( ( 1.0 * g00(U) * gRR(U) ) / ((U*U*g00(U)) - (U0*U0*g00(U0))) );
}

/*El método utilizado para integrar será el Runge-Kutta de cuarto orden*/
void integral_definida()
{
	double limite_inferior, limite_superior, U, Phi, U0, k1, k2, k3, k4, dU;

	U0=0.1;
	limite_inferior=0.0000000001;
	dU=0.000001;

	/*aqui definimos nuestro punto inicial para la integración, el punto U y su valor respectivo de Phi*/

	limite_superior=U0;
	U = limite_inferior;
	Phi = M_PI;
	
	do
	{
		/*printf("%f\n", Phi);*/
		k1 = dPhidR( U , Phi , U0 );
		k2 = dPhidR( U+0.5*dU , Phi+0.5*dU*k1 , U0 );
		k3 = dPhidR( U+0.5*dU , Phi+0.5*dU*k2 , U0 );
		k4 = dPhidR( U+dU , Phi+k3*dU , U0 );
		Phi = Phi + ( k1 + 2.0*k2 + 2.0*k3 + k4 ) * dU/6.0;
		U = U + dU;
		/*if( U < limite_superior )printf("%f\t%f\n",-Phi + 2.0*M_PI, 1.0/U);*/
	}while( U < limite_superior );
	return ;
}

/*Este es el cuerpo principal del programa*/
int main()
{
	integral_definida();
	return 0;
}
